﻿#Skill 5.1 Secure the network environment

#Create Port ACLs
$acl = New-SCPortACL -Name “TENANT_A_VNET1_ACL” -Description “ACL for TENANT A VNET1” -ManagedByNC
New-SCPortACLRule -PortACL $acl -Name “AllowRDPAccess” -Description “Enable RDP Access to VMs” -Type Inbound -Action Allow -Priority 1001 -LocalPortRange 3389
Get-SCVMNetwork -Name "TENANT_A_VNET1" | Set-SCVMNetwork -PortAcl $acl
Get-SCVMSubnet -Name "TENANT_A_SUBNET1" | Set-SCVMSubnet -PortAcl $acl
Get-SCVirtualMachine -Name “VM1” | Get-SCVirtualNetworkAdapter | Set-SCVirtualNetworkAdapter -PortAcl $acl

#Create Global Port ACL
Set-SCVMMServer -VMMServer “VMM.contoso.int” -PortAcl $acl

#Create ACL Rule
New-SCPortACLRule -PortACL $acl -Name “AllowRDPAccess” -Description “Enable RDP Access to VMs” -Type Inbound -Action Allow -Priority 1001 -LocalPortRange 3389

#Configure policies on Network Controller
$rules = @()
$rule = New-Object Microsoft.Windows.NetworkController.AclRule
$rule.ResourceId = “Tenant1_Rule1”
$rule.properties = New-Object Microsoft.Windows.NetworkController.AclRuleProperties
$rule.properties.Protocol = “TCP”
$rule.properties.SourcePortRange = “0-65535”
$rule.properties.DestinationPortRange = “3389”
$rule.properties.Action = “Allow”
$rule.properties.SourceAddressPrefix = “*”
$rule.properties.DestinationAddressPrefix = “192.168.1.101”
$rule.properties.Priority = “1001”
$rule.properties.Type = “Inbound”
$rule.properties.Logging = “Enabled”
$rules += $rule
$aclprops = New-Object Microsoft.Windows.NetworkController.AccessControlListProperties
$aclprops.AclRules = $rules
New-NetworkControllerAccessControlList -ConnectionUri $uri -ResourceId “Tenant1_Subnet1_ACL” -Properties $aclprops
$acl = Get-NetworkControllerAccessControlList -ConnectionUri $uri -ResourceId “Tenant1_Subnet1_ACL”
$subnet = Get-NetworkControllerVirtualSubnet -ConnectionUri $uri -ResourceId “Tenant1_Subnet1” -VirtualNetworkId “Tenant1_VNet1”
$subnet.properites.AccessControList = $acl
New-NetworkControllerVirtualSubnet -ConnectionUri $uri -ResourceId “Tenant1_Subnet1” -VirtualNetworkId “Tenant1_VNet1” -Properties $($subnet.properties)